ghc-7.10.2: The GHC API

Safe Haskell | None
Language | Haskell2010

TcGenGenerics

# Documentation

canDoGenerics :: TyCon -> [Type] -> Validity Source

canDoGenerics1 :: TyCon -> [Type] -> Validity Source

data GenericKind Source

Constructors

Gen0 |
Gen1 |

data MetaTyCons Source

Instances

Outputable MetaTyCons |

genGenericMetaTyCons :: TyCon -> Module -> TcM (MetaTyCons, BagDerivStuff) Source

gen_Generic_binds :: GenericKind -> TyCon -> MetaTyCons -> Module -> TcM (LHsBinds RdrName, FamInst) Source

get_gen1_constrained_tys :: TyVar -> Type -> [Type] Source